C
C     Last change:  RBT   MARCH52006  12:30 PM
C=======================================================================
      SUBROUTINE ATS1AL(ISUM,LCTIM,MXSTP,IMXSTP,ITIM,FNAME,IATS,IOUT,
     &			   	  TMX,TMN,TSM,TSD)
C-----VERSION 28SEPT2004 RBT
C     ******************************************************************
C	READ OUTPUT FLAG AND OPEN TIME STEP INFO FILE
C     ALLOCATE ARRAY STORAGE FOR ADAPTIVE TIME STEPPING MODULE 
C     ******************************************************************
C     SPECIFICATIONS: 
C     ------------------------------------------------------------------
      CHARACTER*200 LINE
	CHARACTER*200 OFILE,FNAME
	INTEGER ZERO,LCTIM,MXSTP,IFREFM,IRK,IOUT,IATS,ITIM,NUM
	REAL TMX,TMN,TSMULT,TSDIV
	PARAMETER (ZERO=0) 
	DATA EXT /'.tim'/
C     ------------------------------------------------------------------
  570 FORMAT(1X,'TIME STEP INFORMATION WILL BE SAVED ON UNIT'
     &,I3)		
  585 FORMAT(1X,I10,' ELEMENTS IN X ARRAY ARE USED BY ATS')
  590 FORMAT(1X,'TIME STEP INFORMATION WILL NOT BE SAVED')
C
C
C1---- READ UNIT / FLAG FOR OUTPUT FILE AND TIME STEP ARRAY DIMENSION (MXSTP)
      LLOC=1
      CALL URDCOM(IATS,IOUT,LINE)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,ITIM,R,IOUT,IATS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,2,MXSTP,R,IOUT,IATS)
C
C2----  IF TIME FILE REQUESTED (ITIM>0) OPEN UNFORMATTED OUTPUT FILE
	IF (ITIM.GT.0) THEN
C2A--- PRINT OUTPUT FILE NUMBER
	   WRITE (IOUT,570) ITIM
C
	   OFILE=FNAME
	   NUM=INDEX(OFILE,' ')
	   WRITE(OFILE(NUM-4:NUM),'(A4)')EXT
	   OPEN (UNIT=ITIM,FILE=OFILE,FORM='BINARY',STATUS='UNKNOWN')
C
C3---- ALLOCATE SPACE FOR THE ARRAY TIM(IF REQUESTED)
		IRK=ISUM
		LCTIM=ISUM
		ISUM=ISUM+MXSTP
C
C4---- CALCULATE & PRINT AMOUNT OF SPACE USED BY ATS PACKAGE.
	    IRK=ISUM-IRK
		WRITE(IOUT,585)IRK
	ELSE
		WRITE(IOUT,590)
		LCTIM=1 
	ENDIF
C
C5---- READ  MAX AND MIN TIMESTEPS AND TIMESTEP FACTORS
      CALL URDCOM(IATS,IOUT,LINE)
	LLOC=1
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,TMX,IOUT,IATS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,TMN,IOUT,IATS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,I,TSM,IOUT,IATS)
      CALL URWORD(LINE,LLOC,ISTART,ISTOP,3,1,TSD,IOUT,IATS)
	IMXSTP=MXSTP
C	
C6---- RETURN.
      RETURN
      END
C
C=======================================================================
      SUBROUTINE ATS1ADV(PTIME,KSTP,DLT)

C-----VERSION 24SEP2004 RBT
C     ******************************************************************
C	ADVANCE TIME STEP BASED ON INITIAL USER-SPECIFIED DELT 
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
	REAL DLT,RKSTP,DIFF
	INTEGER KSTP,IKSTP
	DOUBLE PRECISION PTIME
C     ------------------------------------------------------------------
C
C1--- COMPUTE KSTP BASED ON ELAPSED TIME AND INTIAL DELTA T SIZE
	IKSTP=INT(PTIME/DLT) 
	RKSTP=PTIME/DLT
	DIFF=RKSTP-IKSTP
	IF (DIFF.GT.0.9999)THEN 
	    KSTP=IKSTP+1
	ELSE
		KSTP=IKSTP
	ENDIF
	IF (KSTP.EQ.0) KSTP=1
C
C2---- RETURN
	RETURN
	END
C
C=======================================================================
      SUBROUTINE ATS1RST(DELT,TMX,TMN,TSD,IRST,ICNVG,TIM,MXSTP, 
     & AKSTP,ITIM,NROW,NCOL,NLAY,PERTIM,TOTIM,PTIME) 
C-----VERSION 6JUNE2003 RBT
C     ******************************************************************
C	NON-CONVERGENCE: ADJUST TIME STEP ACCORDINGLY
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
	REAL TMX,TMN,TSD
	INTEGER IRST,ICNVG,MXSTP,AKSTP,ITIM
	DOUBLE PRECISION PTIME
	DIMENSION TIM(MXSTP)
C     ------------------------------------------------------------------
	IRST=0
C
C1---- DID NOT CONVERGE, CHECK DELT AND REDUCE IF POSSIBLE
	IF (ICNVG.NE.1) THEN
		IF (DELT.LE.TMN) THEN
			WRITE(*,5)
    5 FORMAT ('Simulation aborted: ATS - Did not converge with minimum
     & time step')
			STOP
		ELSEIF (DELT.GT.TMN) THEN
			PERTIM=PERTIM-DELT
			TOTIM=TOTIM-DELT
			PTIME=PTIME-DELT
			DELT=DELT/TSD
			IF(DELT.LT.TMN)DELT=TMN
		ENDIF
C
C2---- RESET PERIOD AND TOTAL SIMULATION TIME COUNTERS
		PERTIM=PERTIM+DELT
		TOTIM=TOTIM+DELT
		PTIME=PTIME+DELT
C
C3---- SET RESTART FLAG
		IRST=1
	ELSE
C
C4---- CONVERGED? STORE DELT VALUE IN TIME OUTPUT ARRAY (IF ACTIVATED)
		IF(ITIM.GT.0) TIM(AKSTP)=DELT
	ENDIF
C
C5---- RETURN
	RETURN
	END 
C
C
C=======================================================================
      SUBROUTINE ATS1ADJ(DELT,TMX,TMN,TSM,TSD,KKITER,MXITER,PERTIM,
     &				  PERLEN,ENDPER,KPER,KSTP,TIM,MXSTP,ITIM,RST,
     &				  ITSOC,IPEROC,NSTP,IDE4,ITMX)

C-----VERSION 6MARCH2006 RBT
C     ******************************************************************
C	ADJUST TIME STEP BASED ON CURRENT TIME STEP'S ITERATION RATIO
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
	REAL TMX,TMN,TSM,TSD,MINCV,MAXCV,RATIO,KI,MI,PL,TIM,DT,OCTIME
	INTEGER KKITER,MXITER,ENDPER,NUMSTP,AKSTP,ITIM,MXSTP,FLG,RST
	DIMENSION TIM(MXSTP)
C     ------------------------------------------------------------------
C
	ONE=1.0  
	ENDPER=0
	FLG=0
	RST=0
	KI=KKITER
	MI=MXITER
	IF (IDE4.GT.0)MI=ITMX
	MINCV=0.35
	MAXCV=0.65
	RATIO=KI/MI
C
C1---- IF CONVERGENCE IS WITHIN 35% OF MAXIMUM NUMBER OF ITERATIONS,
C1---- INCREASE BY TSMULT
	IF (RATIO.LT.MINCV) THEN
		DELT=DELT*TSM
C2---- IF CONVERGENCE IS ABOVE 65% OF MAXIMUM, REDUCE BY TSDIV
	ELSEIF (RATIO.GT.MAXCV)THEN
		DELT=DELT/TSD
	ENDIF
C3---- MAKE SURE TMN<DELT<TMX
10	IF(DELT.GT.TMX)DELT=TMX
	IF(DELT.LT.TMN)DELT=TMN
C4---- IF PERIOD LENGTH IS EXCEEDED, ADJUST DELT
	PL=DELT+PERTIM
	IF (PL.GT.PERLEN.AND.PERTIM.NE.PERLEN) THEN
		DELT=PERLEN-PERTIM
	ENDIF
C5---- CONSTRAIN TIME STEP TO REQUESTED OUTPUT CONTROL TIME
   	IF (KPER.EQ.IPEROC)THEN
		OCTIME=ITSOC*(PERLEN/NSTP)
		IF(PL.GT.OCTIME) THEN
			DELT=OCTIME-PERTIM
		ENDIF
	ENDIF
C6---- IF DELT IS LAST STEP IN CURRENT STRESS PERIOD SET FLAG AND RETURN
	IF (PERTIM.GE.PERLEN)THEN
		ENDPER=1
		NUMSTP=KSTP
C7---- IF OUTPUT ACTIVATED, WRITE TIME INFORMATION FOR CURRENT STRESS PERIOD TO OUTPUT FILE
		IF (ITIM.GT.0) THEN
			WRITE (ITIM)KPER,PERLEN,NUMSTP
			WRITE (ITIM)(TIM(I),I=1,NUMSTP)
C8---- RE-INITIALIZE TIME STEP ARRAY
			TIM=0.
		ENDIF
	ENDIF
C
C9---- RETURN
100	RETURN
	END